"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
/**
 * This TypeScript decorator will cause the decorated command to be hidden from all help and
 * "Related commands" screens.
 *
 * @see {@link https://www.typescriptlang.org/docs/handbook/decorators.html#class-decorators}
 */
function isHidden(constructor) {
    return class extends constructor {
        constructor() {
            super(...arguments);
            this.hidden = true;
        }
    };
}
exports.default = isHidden;
